#include "mainwindow.h"
#include "ui_mainwindow.h"
#include <QHBoxLayout>
#include <QOpenGLWidget>
#include <QOpenGLContext>
#include <AppKit/NSOpenGL.h>
#include <QOpenGLFunctions>
#include <QDebug>

class MyGLWidget : public QOpenGLWidget
{
public:
    MyGLWidget(QWidget *parent) : QOpenGLWidget(parent) { }
protected:
    void paintGL() override
    {
        m_v = (m_v+1) % 256;

        QOpenGLFunctions *f = QOpenGLContext::currentContext()->functions();
        f->glClearColor(m_v/255.f, m_v/255.f, m_v/255.f, 1.0f);
        f->glClear(GL_COLOR_BUFFER_BIT);

        NSView *view = (NSView *)winId();
        auto refCount = CFGetRetainCount(view);
        qDebug() << "Ref Count =" << refCount;
        Q_ASSERT(refCount < 1000);

        update();
    }
private:
    int m_v=0;
};

MainWindow::MainWindow(QWidget *parent)
    : QMainWindow(parent)
    , ui(new Ui::MainWindow)
{
    ui->setupUi(this);

    auto hBoxLayout = new QHBoxLayout(ui->centralwidget);
    hBoxLayout->addWidget(new MyGLWidget(this));
    hBoxLayout->addWidget(new MyGLWidget(this));
}

MainWindow::~MainWindow()
{
    delete ui;
}

